#include <string.h>
#include <stdlib.h>

#include <vtree.h>

struct vmod_blobdigest_digest;
struct tus_exp;

/* ============================================================
 * global server splay tree
 */
struct VPFX(tus_server) {
	unsigned				magic;
#define VMOD_TUS_SERVER_MAGIC			0x1055e47e
	unsigned				refcnt;

	VSPLAY_ENTRY(VPFX(tus_server))		entry;

	pthread_mutex_t			mtx;
	char					*vcl_name;
	char					*basedir;
	char					*schemeauth;
	VCL_BYTES				max;
	VCL_DURATION				expires;
	int					basefd;
	struct tus_files			files[1];
	struct vmod_blobdigest_digest		*digest;
	struct tus_exp				*exp;
};

static inline int
tus_server_cmp(const struct VPFX(tus_server) *a,
    const struct VPFX(tus_server) *b) {
	CHECK_OBJ_NOTNULL(a, VMOD_TUS_SERVER_MAGIC);
	CHECK_OBJ_NOTNULL(b, VMOD_TUS_SERVER_MAGIC);
	return (strcmp(a->vcl_name, b->vcl_name));
}
VSPLAY_HEAD(tus_servers, VPFX(tus_server));
struct tus_servers tus_servers[1];
VSPLAY_PROTOTYPE(tus_servers, VPFX(tus_server), entry, tus_server_cmp);
